-------------------------------------------------------------- 
--  Subject : Lazy evaluations, factorial in lisp-style
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

function Cond( A )
  try
    for I:=1 to Card( A ) do
      if A[ I, 1 ] then
        R := EvalObject( A[ I, 2 ], [] )
        raise Break
      end
    end
  except
  end
return R

function Fact( N )
return Cond( [ [ N = 1, 1 ] , [ N > 1, { N * Fact( N - 1 ) } ] ] )

ShowMessage( Fact( 12 ) )

return


