-------------------------------------------------------------- 
--  Subject : ActiveX
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

uses com

constant
  x1Chart      = -4109
  x1WorksSheet = -4167
end

CoInitialize()

object Excel, Workbooks, Add, Worksheets, Range, Columns, Interior, Sheets : Dispatch

try
  Excel.Init( 'Excel.Application' )

  PutProperty( Excel, 'Visible', True )
  Dummy := Excel/Workbooks/Add[ x1WorksSheet ]
  PutProperty( Excel/Workbooks[1]/Worksheets[1], 'Name', 'Virt Data' )

  Sheet := Excel/Workbooks[1]/Worksheets[ 'Virt Data' ]
  for I:=1 to 10 do
    PutProperty( Sheet, 'Cells', [ I, 1, I ] )
  end
  PutProperty( Sheet, 'Cells', [ 11, 1, '=Sum(A1:A10)' ] )

  Range := Excel/Workbooks[1]/Worksheets[ 'Virt Data' ]/Range[ 'C1:F25' ]

  PutProperty( Range, 'Formula', '=RAND()' )
  PutProperty( Range/Columns/Interior, 'ColorIndex', 3 )

  Dummy := Excel/Workbooks[1]/Sheets/Add[ *, *, 1, x1Chart ]

finally

  CoUninitialize()

   writeln( 'COM closed' )
end

return
